%%
%% This is file `newlfm.cls',
%% generated with the docstrip utility.
%%
%% The original source files were:
%%
%% newlfm.dtx  (with options: `package')
%% 
%% \CharacterTable
%%  {Upper-case    \A\B\C\D\E\F\G\H\I\J\K\L\M\N\O\P\Q\R\S\T\U\V\W\X\Y\Z
%%   Lower-case    \a\b\c\d\e\f\g\h\i\j\k\l\m\n\o\p\q\r\s\t\u\v\w\x\y\z
%%   Digits        \0\1\2\3\4\5\6\7\8\9
%%   Exclamation   \!     Double quote  \"     Hash (number) \#
%%   Dollar        \$     Percent       \%     Ampersand     \&
%%   Acute accent  \'     Left paren    \(     Right paren   \)
%%   Asterisk      \*     Plus          \+     Comma         \,
%%   Minus         \-     Point         \.     Solidus       \/
%%   Colon         \:     Semicolon     \;     Less than     \<
%%   Equals        \=     Greater than  \>     Question mark \?
%%   Commercial at \@     Left bracket  \[     Backslash     \\
%%   Right bracket \]     Circumflex    \^     Underscore    \_
%%   Grave accent  \`     Left brace    \{     Vertical bar  \|
%%   Right brace   \}     Tilde         \~}
\NeedsTeXFormat{LaTeX2e}[1996/06/01]
\ProvidesClass{newlfm}
              [2002/3/16 v3.4
               Letter-Fax-Memo LaTeX Document Class]
\newcommand{\ifta}{0}%
\newcommand{\iftb}{0}%
\newcommand{\txa}[1]{}%\ifthenelse{\ifta=1}{\typeout{#1}}{}}%
\newcommand{\txb}[1]{}%\ifthenelse{\iftb=1}{\typeout{#1}}{}}%
\newcommand{\envz}{} \newsavebox{\fba}
\setlength{\voffset}{0in}%
\newlength{\@blka@b}       \newlength{\@blka@a}%
\newlength{\@blkb@b}       \newlength{\@blkb@a}%
\newlength{\@blkc@b}       \newlength{\@blkc@a}%
\newlength{\@dt@sk@b}      \newlength{\@dt@sk@a}%
\newlength{\@addr@fr@sk@b} \newlength{\@addr@fr@sk@a}%
\newlength{\@addr@to@sk@b} \newlength{\@addr@to@sk@a}%
\newlength{\@greet@to@sk@b}\newlength{\@greet@to@sk@a}%
\newlength{\@sig@sk@b}     \newlength{\@sig@sk@a}%
\newlength{\@sig@sp}%
\newlength{\@post@sig@sp@a}
\newlength{\@post@memo@sp}
\newlength{\plz}%
\newlength{\pzz}%
\newlength{\@marg@left}%
\newlength{\@marg@right}%
\newlength{\Mwd}            \setlength{\Mwd}{0in}%
\newlength{\hlhgt}\newlength{\Hhgt}\newlength{\hchgt}\newlength{\hrhgt}%
\newlength{\flhgt}\newlength{\Fhgt}\newlength{\fchgt}\newlength{\frhgt}%
\newlength{\fldth}                 \newlength{\fcdth}\newlength{\frdth}%
\newlength{\Pwd}%
\newsavebox{\SCh}\newsavebox{\SLh}\newsavebox{\SRh}%
\newsavebox{\SCf}\newsavebox{\SLf}\newsavebox{\SRf}%
\newcommand{\@labname}{,nolines,dateno}
\providecommand{\@d@pos}[1]{#1}
\providecommand{\@t@pos}[1]{#1}
\providecommand{\@f@pos}[1]{#1}
\providecommand{\d@pos}[1]{\renewcommand{\@d@pos}{#1}}
\providecommand{\t@pos}[1]{\renewcommand{\@t@pos}{#1}}
\providecommand{\f@pos}[1]{\renewcommand{\@f@pos}{#1}}
\RequirePackage{ifthen}[1997/11/02]%
\newboolean{@addr@fr@l}%
\newboolean{@addr@fr@p}%
\newboolean{@dt@l}                 \setboolean{@dt@l}{true}%
\newboolean{@dt@c}                 \setboolean{@dt@c}{false}%
\newboolean{@dt@p}%
\newboolean{@fax@m@run}            \setboolean{@fax@m@run}{false}%
\newboolean{@side@by@sidea}        \setboolean{@side@by@sidea}{false}%
\newboolean{@side@by@sideb}        \setboolean{@side@by@sideb}{false}%
\newboolean{@greet@p}%
\newboolean{@sig@l}                \setboolean{@sig@l}{true}%
\newboolean{@sig@c}                \setboolean{@sig@l}{false}%
\newboolean{@use@sig}%
\newboolean{@use@sig@nm}%
\newboolean{@lang@amer}            \setboolean{@lang@amer}{true}%
\newboolean{@lang@engl}            \setboolean{@lang@engl}{false}%
\newboolean{@lang@germ}            \setboolean{@lang@germ}{false}%
\newboolean{@lang@frnc}            \setboolean{@lang@frnc}{false}%
\newboolean{@lang@othr}            \setboolean{@lang@othr}{false}%
\newboolean{@lang@pigl}            \setboolean{@lang@pigl}{false}%
\newboolean{@marg@flush@top}       \setboolean{@marg@flush@top}{false}%
\newboolean{@memo@bl}%
\newboolean{@memo@a}
\newboolean{@memo@b}               \setboolean{@memo@b}{false}%
\newboolean{@memo@c}               \setboolean{@memo@c}{false}%
\newboolean{@memo@d}               \setboolean{@memo@d}{false}%
\newboolean{@memo@e}               \setboolean{@memo@e}{true}%
\newboolean{@memo@f}               \setboolean{@memo@f}{true}%
\newboolean{@memo@g}               \setboolean{@memo@g}{true}%
\newboolean{@memo@h}               \setboolean{@memo@h}{false}%
\newboolean{@memo@i}               \setboolean{@memo@i}{false}%
\newboolean{@memo@j}               \setboolean{@memo@j}{false}%
\newboolean{@memo@k}               \setboolean{@memo@k}{false}%
\newboolean{@memo@l}               \setboolean{@memo@l}{false}%
\newboolean{@memo@m}               \setboolean{@memo@m}{false}%
\newboolean{@memo@n}               \setboolean{@memo@n}{false}%
\newboolean{@pr@regard}            \setboolean{@pr@regard}{false}%
\newboolean{@sig@p}%
\newboolean{@sig@mp}%
\newboolean{@addr@to@l}%
\newboolean{@addr@to@p}%
\newboolean{@fax@hdr@pg}%
\newboolean{@fax@RA}%
\newboolean{@fax@RU}%
\newboolean{@fax@bla}              \setboolean{@fax@bla}{true}%
\newboolean{@fax@blb}              \setboolean{@fax@blb}{false}%
\newboolean{@use@all@fr}%
\newboolean{@use@all@to}%
\newboolean{@use@envlab}           \setboolean{@use@envlab}{false}%
\newboolean{@no@cen}               \setboolean{@no@cen}{false}
\newboolean{@no@space}             \setboolean{@no@space}{false}
\newboolean{@b@h}                  \setboolean{@b@h}{false}
\newboolean{@b@f}                  \setboolean{@b@f}{false}
\newboolean{@b@r}                  \setboolean{@b@r}{false}
\newboolean{@b@l}                  \setboolean{@b@l}{false}
\newboolean{@B@h}                  \setboolean{@B@h}{false}
\newboolean{@B@f}                  \setboolean{@B@f}{false}
\newboolean{@B@r}                  \setboolean{@B@r}{false}
\newboolean{@B@l}                  \setboolean{@B@l}{false}
\providecommand{\defaultlanguage}{}%
\providecommand{\@date@phr}{}       \providecommand{\DatePhrase}[1]{}%
\providecommand{\@fax@cover@line}{} \providecommand{\PhrFAXcovp}[1]{}%
\providecommand{\@fax@page@count}{} \providecommand{\PhrFAXpgcnt}[1]{}%
\providecommand{\@email@phr}{}      \providecommand{\PhrEmail}[1]{}  %
\providecommand{\@fax@phr}{}        \providecommand{\PhrFax}[1]{}%
\providecommand{\@pager@phr}{}      \providecommand{\PhrPager}[1]{}%
\providecommand{\@doc@phr}{}        \providecommand{\PhrDocument}[1]{}%
\providecommand{\@phn@phr}{}        \providecommand{\PhrPhone}[1]{}%
\providecommand{\@re@phr}{}         \providecommand{\PhrRe}[1]{}%
\providecommand{\@subre@phr}{}      \providecommand{\PhrSubre}[1]{}%
\providecommand{\@cc@phr}{}         \providecommand{\PhrCc}[1]{}%
\providecommand{\@ps@phr}{}         \providecommand{\PhrPs}[1]{}%
\providecommand{\@m@phr}{}          \providecommand{\PhrMessage}[1]{}%
\providecommand{\@pps@phr}{}        \providecommand{\PhrPps}[1]{}%
\providecommand{\@ppps@phr}{}       \providecommand{\PhrPpps}[1]{}%
\providecommand{\@encl@phr}{}       \providecommand{\PhrEncl}[1]{}%
\providecommand{\@hnto@phr}{}       \providecommand{\PhrTo}[1]{}%
\providecommand{\@hnfr@phr}{}       \providecommand{\PhrFrom}[1]{}%
\providecommand{\@am@phr}{}%
\providecommand{\@regard@phr}{}     \providecommand{\PhrRegard}[1]{}%
\renewcommand{\DatePhrase}[1]{\renewcommand{\@date@phr}{#1}}%
\renewcommand{\PhrFAXcovp}[1]{\renewcommand{\@fax@cover@line}{#1}}%
\renewcommand{\PhrFAXpgcnt}[1]{\renewcommand{\@fax@page@count}{#1}}%
\renewcommand{\PhrEmail}[1]{\renewcommand{\@email@phr}{#1}}%
\renewcommand{\PhrFax}[1]{\renewcommand{\@fax@phr}{#1}}
\renewcommand{\PhrPager}[1]{\renewcommand{\@pager@phr}{#1}}%
\renewcommand{\PhrDocument}[1]{\renewcommand{\@doc@phr}{#1}}%
\renewcommand{\PhrPhone}[1]{\renewcommand{\@phn@phr}{#1}}%
\renewcommand{\PhrRe}[1]{\renewcommand{\@re@phr}{#1}}%
\renewcommand{\PhrSubre}[1]{\renewcommand{\@subre@phr}{#1}}%
\renewcommand{\PhrCc}[1]{\renewcommand{\@cc@phr}{#1}}%
\renewcommand{\PhrPs}[1]{\renewcommand{\@ps@phr}{#1}}%
\renewcommand{\PhrMessage}[1]{\renewcommand{\@m@phr}{#1}}%
\renewcommand{\PhrPps}[1]{\renewcommand{\@pps@phr}{#1}}%
\renewcommand{\PhrPpps}[1]{\renewcommand{\@ppps@phr}{#1}}%
\renewcommand{\PhrEncl}[1]{\renewcommand{\@encl@phr}{#1}}%
\renewcommand{\PhrTo}[1]{\renewcommand{\@hnto@phr}{#1}}%
\renewcommand{\PhrFrom}[1]{\renewcommand{\@hnfr@phr}{#1}}%
\renewcommand{\PhrRegard}[1]{\renewcommand{\@regard@phr}{#1}}%
\renewcommand{\defaultlanguage}{american}%
\renewcommand{\@am@phr}{%
  \DatePhrase{Date}%
  \PhrFAXcovp{FAX Cover Page}%
  \PhrFAXpgcnt{FAX Page Count}%
  \PhrFax{FAX}%
  \PhrPager{Pager}%
  \PhrEmail{E-mail}%
  \PhrDocument{Document}%
  \PhrPhone{Telephone}%
  \PhrRe{Re}%
  \PhrSubre{\ensuremath{\mathrm{Re}_2}}%
  \PhrCc{cc}%
  \PhrPs{Ps}%
  \PhrMessage{Message}%
  \PhrPps{Pps}%
  \PhrPpps{Ppps}%
  \PhrEncl{Encl}%
  \PhrPager{Page}%
  \PhrTo{To}%
  \PhrFrom{From}%
  \PhrRegard{Regarding}%
}
\InputIfFileExists{extracd.tex}%
  {\typeout{Reading alternative macro definitions from extracd.tex}}%
  {\typeout{All language information must be in newlfm.cls}}%
\DeclareOption{french}{\renewcommand{\defaultlanguage}{french}%
                       \setboolean{@lang@frnc}{true} \@fr@phr}%
\DeclareOption{german}{\renewcommand{\defaultlanguage}{german}%
                       \setboolean{@lang@germ}{true} \@gr@phr}%
\DeclareOption{american}{\renewcommand{\defaultlanguage}{american}%
                       \setboolean{@lang@amer}{true} \@am@phr}%
\DeclareOption{english}{\renewcommand{\defaultlanguage}{english}%
                        \setboolean{@lang@engl}{true} \@en@phr}%
\DeclareOption{othlang}{\renewcommand{\defaultlanguage}{othlang}%
                        \setboolean{@lang@othr}{true} \@ot@phr}%
\DeclareOption{piglatin}{\renewcommand{\defaultlanguage}{piglatin}%
                        \setboolean{@lang@pigl}{true} \@pl@phr}%
\DeclareOption{stdmemo}{\setboolean{@addr@fr@p}{false} %
                        \setboolean{@addr@to@p}{false} %
                        \setboolean{@memo@bl}{true}%
                        \setboolean{@greet@p}{false}%
                        \setboolean{@dt@l}{false}%
                        \setboolean{@dt@c}{false}%
                        \setboolean{@dt@p}{false}%
                        \setboolean{@sig@p}{false}%
                        \setboolean{@sig@mp}{true}%
                       }%
\DeclareOption{addrfrl}      {\setboolean{@addr@fr@l}{true}}%
\DeclareOption{addrfrr}      {\setboolean{@addr@fr@l}{false}}%
\DeclareOption{addrtol}      {\setboolean{@addr@to@l}{true}}%
\DeclareOption{addrtor}      {\setboolean{@addr@to@l}{false}}%
\DeclareOption{addrfromleft} {\setboolean{@addr@fr@l}{true}}%
\DeclareOption{addrfromright}{\setboolean{@addr@fr@l}{false}}%
\DeclareOption{addrtoleft}   {\setboolean{@addr@to@l}{true}}%
\DeclareOption{addrtoright}  {\setboolean{@addr@to@l}{false}}%
\providecommand{\boxht}[1]{}  \providecommand{\boxwd}[1]{}
\providecommand{\@boxht}[1]{} \providecommand{\@boxwd}[1]{}
\renewcommand{\boxht}[1]{\renewcommand{\@boxht}{#1}} \boxht{1in}
\renewcommand{\boxwd}[1]{\renewcommand{\@boxwd}{#1}} \boxwd{2.625in}
\DeclareOption{Avery5160}
  {\renewcommand{\@labname}{,Avery5160,nolines,dateno}
   \boxht{71pt}\boxwd{2.625in}}
\DeclareOption{memoaddrto}   {\setboolean{@memo@b}{true}}%
\DeclareOption{memoemailto}  {\setboolean{@memo@k}{true}}%
\DeclareOption{memophoneto}  {\setboolean{@memo@c}{true}}%
\DeclareOption{memopagerto}  {\setboolean{@memo@n}{true}}%
\DeclareOption{memofaxto}    {\setboolean{@memo@d}{true}}%
\DeclareOption{memoaddrfrom} {\setboolean{@memo@h}{true}}%
\DeclareOption{memoemailfrom}{\setboolean{@memo@l}{true}}%
\DeclareOption{memopagerfrom}{\setboolean{@memo@m}{true}}%
\DeclareOption{memophonefrom}{\setboolean{@memo@i}{true}}%
\DeclareOption{memofaxfrom}  {\setboolean{@memo@j}{true}}%
\DeclareOption{memodate}
  {\setboolean{@dt@p}{true}%\typeout{Setting date}
  }
\DeclareOption{memonoto}     {\setboolean{@memo@g}{true}}%
\DeclareOption{memonofr}     {\setboolean{@memo@e}{true}}%
\DeclareOption{memonofrom}%
  {\setboolean{@memo@e}{true}}%
\DeclareOption{memonore}{\setboolean{@memo@f}{true}}%
\DeclareOption{fullmemo}{\setboolean{@addr@fr@p}{false} %
                         \setboolean{@addr@to@p}{false} %
                         \setboolean{@memo@bl}{true}%
                         \setboolean{@greet@p}{false}%
                         \setboolean{@dt@l}{false}%
                         \setboolean{@dt@c}{false}%
                         \setboolean{@dt@p}{false}%
                         \setboolean{@sig@p}{false}%
                         \setboolean{@sig@mp}{false}%
                         \setboolean{@memo@b}{true}%
                         \setboolean{@memo@c}{true}%
                         \setboolean{@memo@d}{true}%
                         \setboolean{@memo@h}{true}%
                         \setboolean{@memo@i}{true}%
                         \setboolean{@memo@j}{true}%
                         \setboolean{@memo@k}{true}%
                         \setboolean{@memo@l}{true}%
                         \setboolean{@memo@m}{true}%
                         \setboolean{@memo@n}{true}%
                        }%
\newcommand{\@opt@slr} {\setboolean{@addr@fr@l}{false}%
                        \setboolean{@addr@fr@p}{true}%
                        \setboolean{@addr@to@p}{true}%
                        \setboolean{@dt@p}{true}%
                        \setboolean{@dt@l}{false}%
                        \setboolean{@dt@c}{false}%
                        \setboolean{@greet@p}{true}%
                        \setboolean{@sig@p}{true}%
                        \setboolean{@sig@mp}{false}%
                        \setboolean{@addr@to@l}{true}%
                        \setboolean{@memo@bl}{false}%
                        \setboolean{@dt@l}{false}%
                        \setboolean{@sig@l}{false}%
                        \setboolean{@sig@c}{false}%
                        \d@pos{1}\t@pos{3}\f@pos{2}}
\DeclareOption{stdltr} {\@opt@slr}
\DeclareOption{stdletter}{\@opt@slr}

\newcommand{\@opt@sln} {\setboolean{@addr@fr@l}{false} %
                        \setboolean{@addr@fr@p}{false} %
                        \setboolean{@addr@to@p}{true} %
                        \setboolean{@dt@p}{true}%
                        \setboolean{@dt@l}{false}%
                        \setboolean{@dt@c}{false}%
                        \setboolean{@greet@p}{true}%
                        \setboolean{@sig@p}{true}%
                        \setboolean{@sig@mp}{false}%
                        \setboolean{@addr@to@l}{true} %
                        \setboolean{@memo@bl}{false}%
                        \setboolean{@dt@l}{false}%
                        \setboolean{@sig@l}{false}%
                        \setboolean{@sig@c}{false}%
                        \d@pos{1}\t@pos{3}\f@pos{2}}%
\DeclareOption{sltrnf} {\@opt@sln}
\DeclareOption{stdletternofrom} {\@opt@sln}

\newcommand{\@opt@blr} {\setboolean{@addr@fr@l}{true}%
                        \setboolean{@addr@fr@p}{true}%
                        \setboolean{@memo@bl}{false}%
                        \setboolean{@addr@to@l}{true}%
                        \setboolean{@dt@l}{true}%
                        \setboolean{@dt@c}{false}%
                        \setboolean{@sig@l}{true}%
                        \setboolean{@sig@c}{false}%
                        \setboolean{@sig@p}{true}%
                        \setboolean{@sig@mp}{false}%
                        \d@pos{1}\t@pos{3}\f@pos{2}}%
\DeclareOption{busltr} {\@opt@blr}
\DeclareOption{busletter} {\@opt@blr}

\newcommand{\@opt@bln} {\setboolean{@addr@fr@l}{true}%
                        \setboolean{@addr@fr@p}{false}%
                        \setboolean{@memo@bl}{false}%
                        \setboolean{@addr@to@l}{true}%
                        \setboolean{@dt@l}{true}%
                        \setboolean{@dt@c}{false}%
                        \setboolean{@sig@l}{true}%
                        \setboolean{@sig@p}{true}%
                        \setboolean{@sig@mp}{false}%
                        \setboolean{@sig@c}{false}%
                        \d@pos{1}\t@pos{3}\f@pos{2}}%
\DeclareOption{bltrnf} {\@opt@bln}
\DeclareOption{busletternofrom} {\@opt@bln}
\DeclareOption{orddft} {\d@pos{1}\t@pos{3}\f@pos{2}}%
\DeclareOption{ordfdt} {\d@pos{2}\t@pos{3}\f@pos{1}}%
\DeclareOption{ordftd} {\d@pos{3}\t@pos{2}\f@pos{1}}%
\DeclareOption{orderdatefromto} {\d@pos{1}\t@pos{3}\f@pos{2}}%
\DeclareOption{orderfromdateto} {\d@pos{2}\t@pos{3}\f@pos{1}}%
\DeclareOption{orderfromtodate} {\d@pos{3}\t@pos{2}\f@pos{1}}%
\DeclareOption{sidebyside}      {\t@pos{0}\f@pos{0}
  \ifthenelse{\@d@pos=1}{\setboolean{@side@by@sideb}{true}}
    {\setboolean{@side@by@sidea}{true}}}
\DeclareOption{margflush}%             Set right marginal block flush
  {\setboolean{@marg@flush@top}{true}}%with top of page.
\DeclareOption{biggap}%                Set the marginal gap between the
  {\setboolean{@gap@small}{false}}%    margin 20pt instead of 10pt.
\DeclareOption{noaddrfr}%              Do not print from-address.
  {\setboolean{@addr@fr@p}{false}}%
\DeclareOption{noaddrfrom}%            Do not print from-address.
  {\setboolean{@addr@fr@p}{false}}%
\DeclareOption{noaddrto}%              Do not print to-address.
  {\setboolean{@addr@to@p}{false}}%
\DeclareOption{addrfrno}%              Do not print from-address.
  {\setboolean{@addr@fr@p}{false}}%
\DeclareOption{addrtono}%              Do not print to-address.
  {\setboolean{@addr@to@p}{false}}%
\DeclareOption{addrfromno}%            Do not print from-address.
  {\setboolean{@addr@fr@p}{false}}%
\DeclareOption{faxhp}%                 Print FAX header page.
  {\setboolean{@fax@hdr@pg}{true}%
   \setboolean{@fax@RA}{false}}%
\DeclareOption{faxheaderpage}%         Print FAX header page.
  {\setboolean{@fax@hdr@pg}{true}%
   \setboolean{@fax@RA}{false}}%
\DeclareOption{faxhba}%                Print fax header block on leader
  {\setboolean{@fax@RA}{true}%         in right top-margin.
   \setboolean{@fax@hdr@pg}{false}}%
\DeclareOption{faxhbb}%                Print fax header block on leader
  {\setboolean{@fax@RU}{true}%         in upper right quad of letter
   \setboolean{@fax@hdr@pg}{false}}%   below header, above letter body.
\DeclareOption{faxbla}%                Print FAX block in \Rheader
  {\setboolean{@fax@bla}{true}\setboolean{@fax@blb}{false}}%
\DeclareOption{faxblb}%
  {\setboolean{@fax@blb}{true}\setboolean{@fax@bla}{false}}%
\DeclareOption{faxblocka}%             Print FAX block in \Rheader
  {\setboolean{@fax@bla}{true}\setboolean{@fax@blb}{false}}%
\DeclareOption{faxblockb}%
  {\setboolean{@fax@blb}{true}\setboolean{@fax@bla}{false}}%
\DeclareOption{greetno}%               Do not print greeting
  {\setboolean{@greet@p}{false}}%
\DeclareOption{dtright}%               Print date right-justified
  {\setboolean{@dt@l}{false}\setboolean{@dt@c}{false}}%
\DeclareOption{dateright}%             Print date right-justified
  {\setboolean{@dt@l}{false}\setboolean{@dt@c}{false}}%
\DeclareOption{dateleft}%              Print date left-justified
  {\setboolean{@dt@l}{true}\setboolean{@dt@c}{false}}%
\DeclareOption{datecenter}%            Print date centered
  {\setboolean{@dt@l}{false}\setboolean{@dt@c}{true}}%
\DeclareOption{dtleft}%                Print date left-justified
  {\setboolean{@dt@l}{true}\setboolean{@dt@c}{false}}%
\DeclareOption{dtcenter}%              Print date centered
  {\setboolean{@dt@l}{false}\setboolean{@dt@c}{true}}%
\DeclareOption{dateno}%                Do not print date
  {\setboolean{@dt@p}{false}}%
\DeclareOption{dateyes}%               Print date
  {\setboolean{@dt@p}{true}}%
\DeclareOption{sigright}%              Print signature right-justified
  {\setboolean{@sig@l}{false}\setboolean{@sig@c}{false}} %
\DeclareOption{sigleft}%         Print signature left-justified
  {\setboolean{@sig@l}{true}\setboolean{@sig@c}{false}}%
\DeclareOption{sigcenter}%       Print signature centered
  {\setboolean{@sig@l}{false}\setboolean{@sig@c}{true}}%
\DeclareOption{sigright}%        Print signature right-justified
  {\setboolean{@sig@l}{false}\setboolean{@sig@c}{false}} %
\DeclareOption{signatureleft}%         Print signature left-justified
  {\setboolean{@sig@l}{true}\setboolean{@sig@c}{false}}%
\DeclareOption{signaturecenter}%       Print signature centered
  {\setboolean{@sig@l}{false}\setboolean{@sig@c}{true}}%
\DeclareOption{signatureright}%        Print signature right-justified
  {\setboolean{@sig@l}{false}\setboolean{@sig@c}{false}} %
\DeclareOption{sigleft}%               Print signature left-justified
  {\setboolean{@sig@l}{true}\setboolean{@sig@c}{false}}%
\DeclareOption{sigcenter}%             Print signature centered
  {\setboolean{@sig@l}{false}\setboolean{@sig@c}{true}}%
\DeclareOption{prafr}%                 Print all from \info.
  {\setboolean{@use@all@fr}{true}}%
\DeclareOption{prato}%                 Print all to \info.
  {\setboolean{@use@all@to}{true}}%
\DeclareOption{printallfrom}%          Print all from \info.
  {\setboolean{@use@all@fr}{true}}%
\DeclareOption{printallto}%            Print all to \info.
  {\setboolean{@use@all@to}{true}}%
\DeclareOption{blankheader}{\setboolean{@b@h}{true}}%
\DeclareOption{blankfooter}{\setboolean{@b@f}{true}}%
\DeclareOption{blanklmargin}{\setboolean{@b@l}{true}}%
\DeclareOption{blankrmargin}{\setboolean{@b@r}{true}}%
\DeclareOption{blankleftmargin}{\setboolean{@b@l}{true}}%
\DeclareOption{blankrightmargin}{\setboolean{@b@r}{true}}%
\DeclareOption{Blankheader}{\setboolean{@B@h}{true}}%
\DeclareOption{Blankfooter}{\setboolean{@B@f}{true}}%
\DeclareOption{Blankleftmargin}{\setboolean{@B@l}{true}}%
\DeclareOption{Blankrightmargin}{\setboolean{@B@r}{true}}%
\DeclareOption{Blankall}%
  {\setboolean{@B@f}{true}\setboolean{@B@l}{true}%
   \setboolean{@B@h}{true}\setboolean{@B@r}{true}}%
\DeclareOption{blankall}%
  {\setboolean{@b@f}{true}\setboolean{@b@l}{true}%
   \setboolean{@b@h}{true}\setboolean{@b@r}{true}}%
\DeclareOption{Blank}%
  {\setboolean{@B@f}{true}\setboolean{@B@l}{true}%
   \setboolean{@B@h}{true}\setboolean{@B@r}{true}%
   \setboolean{@b@f}{true}\setboolean{@b@l}{true}%
   \setboolean{@b@h}{true}\setboolean{@b@r}{true}}%
\DeclareOption{useenvlab}{\setboolean{@use@envlab}{true}}%
\ExecuteOptions{letterpaper,stdletter,oneside,final,american,memoa}%
\ProcessOptions%
\LoadClassWithOptions{letter}%
\setlength{\itemsep}{.2em}%
\setlength{\topsep}{.2em}%
\setlength{\partopsep}{0\p@}%
\setlength{\arraycolsep}{5\p@}%
\setlength{\tabcolsep}{6\p@}%
\setlength{\arrayrulewidth}{.4\p@}%
\setlength{\doublerulesep}{2\p@}%
\setlength{\tabbingsep}{\labelsep}%
\skip\@mpfootins = \skip\footins%
\setlength{\fboxsep}{3\p@}%
\setlength{\fboxrule}{.4\p@}%
\renewcommand{\theequation}{\@arabic\c@equation}%
\renewcommand{\footnoterule}{%
  \kern-\p@%
  \hrule \@width .4\columnwidth%
  \kern .6\p@}%
\long\def\@makefntext#1{%
    \noindent \hangindent 5\p@%
    \hb@xt@5\p@{\hss\@makefnmark}#1}%
\RequirePackage{geometry}[1998/04/08]%
\RequirePackage{addrset}%
\RequirePackage{fancyhdr}%
\IfFileExists{envlab.sty}{\RequirePackage{envlab}}{}%
\RequirePackage{chngpage}%
\@ifundefined{ps@@empty}{%
  \ClassError{newlfm}{The version of fancyhdr.sty is not correct and
    up-to-date.  Please obtain a recent copy of fancyhdr.sty (Version 1.99d
    or later) from CTAN.}
  {Go to CTAN and download the current version of fancyhdr.sty}}{}
\RequirePackage{calc}[1997/11/11]%
\RequirePackage{graphicx}[1997/06/09]%
\newcounter{figure}
\renewcommand{\thefigure}{\@arabic\c@figure}
\providecommand{\figurename}{}
\providecommand{\tablename}{}
\renewcommand{\figurename}{Figure}
\renewcommand{\tablename}{Table}

\def\fps@figure{tbp}
\def\ftype@figure{1}
\def\ext@figure{lof}
\def\fnum@figure{\figurename~\thefigure}
\newenvironment{figure}
               {\@float{figure}}
               {\end@float}
\newenvironment{figure*}
               {\@dblfloat{figure}}
               {\end@dblfloat}
\newcounter{table}
\renewcommand\thetable{\@arabic\c@table}
\def\fps@table{tbp}
\def\ftype@table{2}
\def\ext@table{lot}
\def\fnum@table{\tablename~\thetable}
\newenvironment{table}
               {\@float{table}}
               {\end@float}
\newenvironment{table*}
               {\@dblfloat{table}}
               {\end@dblfloat}
\newlength\abovecaptionskip
\newlength\belowcaptionskip
\setlength\abovecaptionskip{10\p@}
\setlength\belowcaptionskip{0\p@}
\long\def\@makecaption#1#2{%
  \vskip\abovecaptionskip
  \sbox\@tempboxa{#1: #2}%
  \ifdim \wd\@tempboxa >\hsize
    #1: #2\par
  \else
    \global \@minipagefalse
    \hb@xt@\hsize{\hfil\box\@tempboxa\hfil}%
  \fi
  \vskip\belowcaptionskip}
\newcommand{\section}[1]{{\Large {\bfseries #1}}}
\newcommand{\monthname}{% timestamp function
  \ifcase\month%
    \or January\or February\or March\or April
    \or May\or June%
    \or July\or August\or September\or October
    \or November\or December%
  \fi%
}%
\newcommand{\timestring}{%
  \begingroup%
    \count0 = \time \divide\count0 by 60%
    \count2 = \count0 % the hour%
    \count4 = \time \multiply\count0 by 60%
    \advance\count4 by -\count0 % the minute%
    \ifnum\count4<10 \toks1 = {0}    \else \toks1 = {}\fi%
    \ifnum\count2<12 \toks0 = {A.M.} %
      \else \toks0 = {P.M.}\advance\count2 by -12\fi%
    \ifnum\count2=0 \count2 = 12 \fi % make midnight 12%
    {\number\count2:\the\toks1 \number\count4%
    \thinspace \the\toks0}%
  \endgroup%
}%
\newcommand{\timestamp}
  {\number\day\space\monthname\space\number\year,\space\timestring}%
\newcommand{\datestamp}
  {\monthname\space\number\day,\space\number\year}%
\newboolean{@hl} \setboolean{@hl}{true}
\newboolean{@fl} \setboolean{@fl}{true}
\newcommand{\noheadline}{\setboolean{@hl}{false}}
\newcommand{\nofootline}{\setboolean{@fl}{false}}
\newcommand{\nolines}{\setboolean{@fl}{false}\setboolean{@hl}{false}}
\newcommand{\@plhl}{1}\newcommand{\nopheadline}
  {\renewcommand{\@plhl}{0}}%
\newcommand{\@plfl}{1}\newcommand{\nopfootline}
  {\renewcommand{\@plfl}{0}}%
\fancypagestyle{plain}{%
  \fancyhf{}%
  \fancyfoot[L]{\@Lfooter}%
  \fancyfoot[C]{\@Cfooter}%
  \fancyfoot[R]{\@Rfooter}%
  \fancyhead[L]{\@Lheader
    \ifempty{\@LUheader}{}
      {\vspace*{-.5in}
       \@LUheader \vspace*{.5in}}
  }%   % section 2 goes here if we go to plan b
  \fancyhead[R]{\@Rheader
    \ifempty{\@RUheader}{}{}}%
  \fancyhead[C]{\@Cheader}%
}%
\providecommand{\@Lfooter}{}    \providecommand{\@Cfooter}{}%
\providecommand{\@Rfooter}{}    \providecommand{\@lfooter}{}%
\providecommand{\@cfooter}{}    \providecommand{\@rfooter}{}%
\providecommand{\@LOfooter}{}   \providecommand{\@COfooter}{}%
\providecommand{\@ROfooter}{}   \providecommand{\@Lheader}{}%
\providecommand{\@Cheader}{}    \providecommand{\@Rheader}{}%
\providecommand{\@lheader}{}    \providecommand{\@cheader}{}%
\providecommand{\@rheader}{}    \providecommand{\@LUheader}{}%
\providecommand{\@CUheader}{}   \providecommand{\@RUheader}{}%
\providecommand{\@Rmarg}{}      \providecommand{\@Lmarg}{}%
\providecommand{\@rmarg}{}      \providecommand{\@lmarg}{}%
\newcommand*{\Lfooter}[1]{\renewcommand{\@Lfooter}{#1}}%
\newcommand*{\Cfooter}[1]{\renewcommand{\@Cfooter}{#1}}%
\newcommand*{\Rfooter}[1]{\renewcommand{\@Rfooter}{#1}}%
\newcommand*{\LOfooter}[1]{\renewcommand{\@LOfooter}{#1}}%
\newcommand*{\COfooter}[1]{\renewcommand{\@COfooter}{#1}}%
\newcommand*{\ROfooter}[1]{\renewcommand{\@ROfooter}{#1}}%
\newcommand*{\lfooter}[1]{\renewcommand{\@lfooter}{#1}}%
\newcommand*{\cfooter}[1]{\renewcommand{\@cfooter}{#1}}%
\newcommand*{\rfooter}[1]{\renewcommand{\@rfooter}{#1}}%
\Rfooter{} \Cfooter{} \Lfooter{}%
\ROfooter{} \COfooter{} \LOfooter{}%
\rfooter{} \cfooter{} \lfooter{}%
\newcommand*{\Lheader}[1]{\renewcommand{\@Lheader}{#1}}%
\newcommand*{\Cheader}[1]{\renewcommand{\@Cheader}{#1}}%
\newcommand*{\Rheader}[1]{\renewcommand{\@Rheader}{#1}}%
\newcommand*{\LUheader}[1]{\renewcommand{\@LUheader}{#1}}%
\newcommand*{\CUheader}[1]{\renewcommand{\@CUheader}{#1}}%
\newcommand*{\RUheader}[1]{\renewcommand{\@RUheader}{#1}}%
\newcommand*{\lheader}[1]{\renewcommand{\@lheader}{#1}}%
\newcommand*{\cheader}[1]{\renewcommand{\@cheader}{#1}}%
\newcommand*{\rheader}[1]{\renewcommand{\@rheader}{#1}}%
\Rheader{} \Cheader{} \Lheader{}%
\RUheader{} \CUheader{} \LUheader{}%
\rheader{} \cheader{} \lheader{}%
\newcommand*{\Rmargin}[1]{\renewcommand{\@Rmarg}{#1}}%
\newcommand*{\Lmargin}[1]{\renewcommand{\@Lmarg}{#1}}%
\newcommand*{\rmargin}[1]{\renewcommand{\@rmarg}{#1}}%
\newcommand*{\lmargin}[1]{\renewcommand{\@lmarg}{#1}}%
\Rmargin{} \Lmargin{} \rmargin{} \lmargin{}%
\newcommand{\Prnt@Chk}[7]{
  \ifthenelse{\boolean{#1}}{\ifempty{#6}{}{
    \vspace*{-2\parskip}\vspace*{#6}}}{}
  \ifthenelse{\boolean{#1}}%
    {\ifthenelse{\boolean{#2}}{\begin{flushleft}{#4}\end{flushleft}}%
    {\ifthenelse{\boolean{#3}}%
      {\begin{center}{#4}\end{center}}%
      {\begin{flushright}{#4}\end{flushright}}}%
    }{}%
  \ifthenelse{\boolean{#1}}{#5}{}%
  \ifthenelse{\boolean{#1}}{\ifempty{#7}{}%
    {\vspace*{-2\parskip}\vspace*{#7}}}{}%
}%
\newcommand{\fixphr}[2]{\strut & \parbox[t]{\the\pc}{#1} #2 \\}%
\renewcommand{\ifta}{0}
\newcommand{\memosec}{%
  \renewcommand{\ifta}{0}%
  \noindent\ignorespaces%
  \newlength{\pa}\newlength{\pb}%
  \newlength{\pc}\newlength{\pd}%
  \settowidth{\pa}{{\large\bf \@hnfr@phr:\hspace*{1.25em}}}%
  \setlength{\pb}{\textwidth-\pa-.1em}%
  \settowidth{\pc}{\@phn@phr:\hspace*{2em}}%
  \settowidth{\pd}{\@fax@phr:\hspace*{2em}}%
  \ifthenelse{\lengthtest{\pc<\pd}}{\setlength{\pc}{\the\pd}}{}%
  \settowidth{\pd}{\@pager@phr:\hspace*{2em}}
  \ifthenelse{\lengthtest{\pc<\pd}}{\setlength{\pc}{\the\pd}}{}%
  \settowidth{\pd}{\@email@phr:\hspace*{2em}}
  \ifthenelse{\lengthtest{\pc<\pd}}{\setlength{\pc}{\the\pd}}{}%
  { \Large \vspace*{-1em}\setlength{\tabcolsep}{0pt}%
    \setboolean{@memo@a}{false}%
    \begin{flushleft}%
      \begin{tabular}{p{\the\pa}l}%
        \ifthenelse{\boolean{@memo@g}}%
          {\setboolean{@memo@a}{true}%
           \strut {\bf \@hnto@phr:} & \@name@to \strut \\%
          \ifthenelse{\boolean{@memo@b}}%
            {\strut & \parbox[t]{\the\pb}%
              {\@addr@to\strut}\strut\\}{}%
          \ifthenelse{\boolean{@memo@c}}%
            {\fixphr{\@phn@phr:}{\@phn@to}}{}%
          \ifthenelse{\boolean{@memo@d}}%
            {\fixphr{\@fax@phr:}{\@fax@to}}{}%
          \ifthenelse{\boolean{@memo@n}}%
            {\fixphr{\@pager@phr:}{\@pager@to}}{}%
          \ifthenelse{\boolean{@memo@k}}%
            {\fixphr{\@email@phr:}{\@email@to}}{}%
          }{}%
        \ifthenelse{\boolean{@memo@e}}
         {\setboolean{@memo@a}{true}%
          \strut {\bf \@hnfr@phr:} &{\@name@fr} \strut \\%
          \ifthenelse{\boolean{@memo@h}}{\strut & %
            \parbox[t]{\the\pb}{\@addr@fr \strut} \strut \\}{}%
          \ifthenelse{\boolean{@memo@i}}%
            {\fixphr{\@phn@phr:}{\@phn@fr}}{}%
          \ifthenelse{\boolean{@memo@j}}%
            {\fixphr{\@fax@phr:}{\@fax@fr}}{}%
          \ifthenelse{\boolean{@memo@m}}%
            {\fixphr{\@pager@phr:}{\@pager@fr}}{}%
          \ifthenelse{\boolean{@memo@l}}%
            {\fixphr{\@email@phr:}{\@email@fr}}{}%
        }{}%
        \ifthenelse{\boolean{@memo@f}}{\setboolean{@memo@a}{true}%
          \strut {\bf \@re@phr:}   &  {\@re@line} \\%
        }{}%
        \ifthenelse{\boolean{@dt@p}}%
          {\strut {\bf \@date@phr:} & \@xdate \\}{}
        \ifthenelse{\boolean{@memo@a}}{\hline}{}%
      \end{tabular}%
    \end{flushleft}%
  }%
  \vspace*{\@post@memo@sp}\noindent\par%
}%
\InputIfFileExists{memosec.tex}%
  {\typeout{Reading {\tt memosec.tex}}}%
  {\typeout{The default definition for memosec is used.}}%
\newlength{\cmndlen}%
\newlength{\extrlen}%
\newcommand*{\faxpage}{%
  \newpage\c@page\@ne\interlinepenalty=200%
  \thispagestyle{empty}%
  \begin{center}%
    \framebox{\Huge{\@fax@cover@line}} \\%
    \vspace*{.5in}%
    \Large{\@fax@page@count: \ref{totpage}} \\
    \vspace*{.5in}%
    \Large{\timestamp} \\%
    \rule{\textwidth}{2pt}%
  \end{center}%
  \settowidth{\cmndlen}{\LARGE{\@hnto@phr:}}%
  \settowidth{\extrlen}{\LARGE{\@hnfr@phr:}}%
  \ifthenelse{\lengthtest{\cmndlen<\extrlen}}%
    {\setlength{\cmndlen}{\extrlen}}{}%
  \settowidth{\extrlen}{\LARGE{\@m@phr:}}%
  \ifthenelse{\lengthtest{\cmndlen<\extrlen}}%
    {\setlength{\cmndlen}{\extrlen}}{}%
  \setlength{\extrlen}{\the\textwidth-\the\cmndlen}%
  \begin{tabular}{p{\the\cmndlen}p{\the\extrlen}}%
  \LARGE{\@hnto@phr:} & %
    \parbox[t]{\extrlen}{\@name@to \strut \\ \@addr@to \strut%
      \ifempty{\@phn@to}{}{\\ \@phn@phr:\space\@phn@to \strut}%
      \ifempty{\@phnb@to}{}{\\ \@phn@phr:\space\@phnb@to \strut}%
      \ifempty{\@phnc@to}{}{\\ \@phn@phr:\space\@phnc@to \strut}%
      \ifempty{\@phnd@to}{}{\\ \@phn@phr:\space\@phnd@to \strut}%
      \ifempty{\@fax@to}{}{\\ \@fax@phr:\space\@fax@to \strut}} \\%
  \hline \vspace*{5pt}%
  \LARGE{\@hnfr@phr:} & \vspace*{5pt}%
    \parbox[t]{\extrlen}{\@name@fr \strut \\ \@addr@fr \strut %%
      \ifempty{\@phn@fr}{}{\\ \@phn@phr:\space\@phn@fr \strut}%
      \ifempty{\@phnb@fr}{}{\\ \@phn@phr:\space\@phnb@fr \strut}%
      \ifempty{\@phnc@fr}{}{\\ \@phn@phr:\space\@phnc@fr \strut}%
      \ifempty{\@phnd@fr}{}{\\ \@phn@phr:\space\@phnd@fr \strut}%
      \ifempty{\@fax@fr}{}{\\ \@fax@phr:\space\@fax@fr \strut}} \\%
  \hline%
  \ifempty{\@fax@mssg}{}{ \strut%
    \LARGE{\@m@phr:} \strut &%
    \parbox[t]{\extrlen}{\strut \@fax@mssg} \strut \\ \hline}%
  \end{tabular}%
}%
\InputIfFileExists{faxpage.tex}%
  {\typeout{Reading FAX page definitions from faxpage.tex}}%
  {\typeout{faxpage definitions stored in newlfm.cls}}%
\newcommand*{\yaxpage}{%
  \newpage\c@page\@ne\interlinepenalty=200%
  \thispagestyle{empty}%
  \begin{center}%
    \framebox{\Huge{\@fax@cover@line}} \\%
    \vspace*{.5in}%
    \Large{\@fax@page@count: \ref{totpage}} \\
    \vspace*{.5in}%
    \Large{\timestamp} \\%
    \rule{\textwidth}{2pt}%
  \end{center}%
  \settowidth{\cmndlen}{\LARGE{\@hnto@phr:}}%
  \settowidth{\extrlen}{\LARGE{\@hnfr@phr:}}%
  \ifthenelse{\lengthtest{\cmndlen<\extrlen}}%
    {\setlength{\cmndlen}{\extrlen}}{}%
  \settowidth{\extrlen}{\LARGE{\@m@phr:}}%
  \ifthenelse{\lengthtest{\cmndlen<\extrlen}}%
    {\setlength{\cmndlen}{\extrlen}}{}%
  \setlength{\extrlen}{\the\textwidth-\the\cmndlen}%
  \begin{tabular}{p{\the\cmndlen}p{\the\extrlen}}%
  \LARGE{\@hnto@phr:} & %
    \parbox[t]{\extrlen}{\begin{tabular}{ll}%
                         \multicolumn{2}{l}{\@name@to \strut} \\%
                         \multicolumn{2}{l}{\@addr@to \strut} \\ %
      \ifpempty{\@phn@to}{} {\@phn@phr: & \@phn@to \\ }%
      \ifpempty{\@phnb@to}{}{\@phn@phr: & \@phnb@to \\}%
      \ifpempty{\@phnc@to}{}{\@phn@phr: & \@phnc@to \\}%
      \ifpempty{\@phnd@to}{}{\@phn@phr: & \@phnd@to \\}%
      \ifpempty{\@fax@to}{} {\@fax@phr: & \@fax@to \\}\end{tabular}}%
  \hline \vspace*{5pt}%
  \LARGE{\@hnfr@phr:} & \vspace*{5pt}%
    \parbox[t]{\extrlen}{\@name@fr \strut \\ \@addr@fr \strut %%
      \ifpempty{\@phn@fr}{}{\\ \@phn@phr:\space\@phn@fr \strut}%
      \ifpempty{\@phnb@fr}{}{\\ \@phn@phr:\space\@phnb@fr \strut}%
      \ifpempty{\@phnc@fr}{}{\\ \@phn@phr:\space\@phnc@fr \strut}%
      \ifpempty{\@phnd@fr}{}{\\ \@phn@phr:\space\@phnd@fr \strut}%
      \ifpempty{\@fax@fr}{}{\\ \@fax@phr:\space\@fax@fr \strut}} \\%
  \hline%
  \ifempty{\@fax@mssg}{}{ \strut%
    \LARGE{\@m@phr:} \strut &%
    \parbox[t]{\extrlen}{\strut \@fax@mssg} \strut \\ \hline}%
  \end{tabular}%
}%
\newcommand{\faxblocka}{%
  \sbox{\fba}{%
    \framebox[2.5in]{\parbox[b]{2.5in}{\setlength{\tabcolsep}{0pt}
    \begin{tabular}{p{.5in}p{2in}}
    \multicolumn{2}{l}{\Large \hspace*{.25in}
      \@fax@phr{} \@doc@phr} \\ \hline
      \@hnfr@phr:\space & \@name@fr \\
      \@fax@phr:\space & \@fax@fr \\ \hline
      \@hnto@phr:\space & \@name@to \\
      \@fax@phr:\space & \@fax@to \\ \hline
      \@re@phr: & \@re@line
    \end{tabular}}}}}
\newcommand{\faxblockb}{%
  {\parbox[t]{\textwidth}{\fbox{%
    \begin{tabular}{llll}%
    \@hnfr@phr:\space & \@name@fr & \@hnto@phr:\space & \@name@to \\%
    \@fax@phr:\space & \@fax@fr & \@fax@phr:\space & \@fax@to \\%
    \@phn@phr:\space & \@phn@fr & \@phn@phr:\space & \@phn@to \\%
    \@re@phr: & \multicolumn{3}{l}{\parbox[t]{2in}{\@re@line}} \\%
    \end{tabular}%
}}}}%
\newcommand{\ifempty}[3]%
  {\ifthenelse{\equal{#1}{}}{#2}{#3}}%
\newcommand{\ifpempty}[3]%
  {\ifthenelse{\equal{\protect#1}{}}{#2}{#3}}%
\newlength{\addrlen}%
\newsavebox{\addrl}%
\newlength{\addrmen}%
\newsavebox{\addrm}%
\newboolean{@greet@l}%
\newcommand{\@prnt@sec}[1]{%
  \ifthenelse{#1=\@d@pos}%
    {\Prnt@Chk{@dt@p}{@dt@l}{@dt@c}{\@xdate}{}{\@dt@sk@b}{\@dt@sk@a}}%
    {}%
  \ifthenelse{#1=\@f@pos}%
    {\Prnt@Chk{@addr@fr@p}{@addr@fr@l}{@no@cen}
      {\usebox{\addrl}}{}{\@addr@fr@sk@b}{\@addr@fr@sk@a}}%
    {}%
  \ifthenelse{#1=\@t@pos}%
    {\Prnt@Chk{@addr@to@p}{@addr@to@l}{@no@cen}%
      {\@name@to \strut \\ \@addr@to \strut}{}{}{\@addr@to@sk@a}}%
    {}%
}
\newcounter{@c@pos}
\newcommand*{\openlfm}{%
  \renewcommand{\ifta}{0}%
  \ifempty{\@Lmarg}{}%
    {\settowidth{\hchgt}{\@Lmarg}%
     \reversemarginpar%
     \setlength{\Mwd}{15pt}%
     \addtolength{\Mwd}{\hchgt}%
     \addtolength{\Mwd}{-\@lm@top@d}
     \ifthenelse{\boolean{@marg@flush@top}}%
       {\marginpar{\vspace*{-\the\Mwd} \@Lmarg}}%
       {\marginpar{\@Lmarg}}%
     \setlength{\Mwd}{\hchgt}%
     \setlength{\@marg@left}{\@lm@sep@l}%
    }%
  \ifpempty{\@LUheader}{}{\@LUheader \hfill}%
  \ifpempty{\@CUheader}{}{\hfill \@CUheader \hfill}%
  \ifpempty{\@RUheader}{}{\hfill \@RUheader}%
  \ifthenelse{\boolean{@memo@bl}}%
    {{\memosec}\setboolean{@dt@p}{false}%
        \setboolean{@no@space}{true}}% %Memo
       {}%
  \sbox{\addrl}{\noindent\setlength{\tabcolsep}{-3pt}
    \raggedleft\begin{tabular}{l@{}}
    \noindent\ignorespaces\@addr@fr\end{tabular}}%
  \settowidth{\addrlen}{\usebox{\addrl}}%
  \sbox{\addrl}{\noindent\setlength{\tabcolsep}{-3pt}
    \parbox[t]{\addrlen}{\noindent
    \begin{tabular}{l@{}}
      \ignorespaces\@addr@fr\end{tabular}}}
  \sbox{\addrm}{\noindent\setlength{\tabcolsep}{-3pt}
    \raggedleft\begin{tabular}{l@{}}
    \noindent\ignorespaces\@name@to \strut \\ \@addr@to\end{tabular}}%
  \settowidth{\addrmen}{\usebox{\addrm}}%
  \sbox{\addrm}{\noindent\setlength{\tabcolsep}{-3pt}
    \parbox[t]{\addrmen}{\noindent
    \begin{tabular}{l@{}}
      \ignorespaces\@name@to \strut \\ \@addr@to\end{tabular}}}
  \ifthenelse{\boolean{@no@space}}{} {%
    \ifthenelse{\boolean{@side@by@sidea}}
      {\par\noindent{\usebox{\addrm} \hfill \usebox{\addrl}}}
      {}%
    \setcounter{@c@pos}{1}%
    \@prnt@sec{\the@c@pos}%
    \setcounter{@c@pos}{2}%
    \@prnt@sec{\the@c@pos}%
    \setcounter{@c@pos}{3}%
    \@prnt@sec{\the@c@pos}%
    \ifthenelse{\boolean{@side@by@sideb}}
      {\par\noindent{\usebox{\addrm} \hfill \usebox{\addrl}}}
      {}%
    \setboolean{@greet@l}{true}%
    \ifthenelse{\boolean{@pr@regard}}{\@regard@phr: \@regard@line}{}%
    \Prnt@Chk{@greet@p}{@greet@l}{@no@cen}%
      {\par\@greet@to\par\nobreak}{}{}{\@greet@to@sk@a}%
  } %
}%
\newcommand{\closlfm}{%
  \renewcommand{\ifta}{0}%
  \par\nobreak%
  \vspace*{\@sig@sk@b}%
  \stopbreaks%
  \noindent%
  \hspace*{\longindentation}%
  \Prnt@Chk{@sig@p}{@sig@l}{@no@cen}%
    {\parbox{\indentedwidth}{%
       \ignorespaces \@closeline \hspace*{.01pt} \\%
       \vspace*{2\parskip}%
       \ifthenelse{\boolean{@use@sig}}{\@sig@fr}%
         {\vspace*{\@sig@sp}} \\%
       \vspace*{2\parskip}%
       \ifthenelse{\boolean{@use@sig@nm}}{\@sig@nm}{\@name@fr}}%
    }{}{\@sig@sk@b}{\@sig@sk@a}%
}%
\newcommand*{\@post@sig@bl}[2]{%
  \ifempty{#2}{}{%
    \par\noindent%
    \parbox[t]{\textwidth}{%
      \setlength{\pzz}{\textwidth}%
      \settowidth{\plz}{{\small\normalfont#1:}}%
      \addtolength{\pzz}{-\plz} %
      \@hangfrom{{\small\normalfont#1: }}%
      \ignorespaces \parbox[t]{\pzz}{{\small#2}}\strut}\par}%
  \vspace*{\@post@sig@sp@a}%
}%
\newcommand*{\sztmarg}[1]%
  {\renewcommand{\@top@m}{#1}}       \sztmarg{10pt}%
\newcommand*{\bottommarginskip}[1]%
  {\renewcommand{\@bot@m}{#1}}
\newcommand*{\spbmarg}[1]%
  {\renewcommand{\@bot@m}{#1}}       \spbmarg{20pt}%
\newcommand*{\headermarginskip}[1]%
  {\renewcommand{\@head@m}{#1}}
\newcommand*{\sphmarg}[1]%
  {\renewcommand{\@head@m}{#1}}      \sphmarg{20pt}%
\newcommand*{\rightmarginsize}[1]%
  {\renewcommand{\@right@m}{#1}\setlength{\@marg@right}{#1}}
\newcommand*{\szrmarg}[1]%
  {\renewcommand{\@right@m}{#1}\setlength{\@marg@right}{#1}}
\szrmarg{72pt}%
\newcommand*{\szlmarg}[1]%
  {\renewcommand{\@left@m}{#1}\setlength{\@marg@left}{#1}}
\newcommand*{\leftmarginsize}[1]%
  {\renewcommand{\@left@m}{#1}\setlength{\@marg@left}{#1}}
\szlmarg{72pt}%
\newcommand*{\leftmargintopdist}[1]{\renewcommand{\@lm@top@d}{#1}%
  \setboolean{@marg@flush@top}{true}}%
\newcommand*{\splmargt}[1]{\renewcommand{\@lm@top@d}{#1}%
  \setboolean{@marg@flush@top}{true}}%
\splmargt{0pt}\setboolean{@marg@flush@top}{false}%
\newcommand*{\leftmarginskipleft}[1]{\renewcommand{\@lm@sep@l}{#1}}%
\newcommand*{\splmargl}[1]{\renewcommand{\@lm@sep@l}{#1}}%
\splmargl{10pt}%
\newcommand*{\leftmarginskipright}[1]{\renewcommand{\@lm@sep@r}{#1}}%
\newcommand*{\splmargr}[1]{\renewcommand{\@lm@sep@r}{#1}}%
\splmargr{10pt}%
\newcommand*{\dateskipbefore}[1]{\setlength{\@dt@sk@b}{#1}}%
\newcommand*{\spbefdate}[1]{\setlength{\@dt@sk@b}{#1}}%
\spbefdate{2\baselineskip}%
\newcommand*{\dateskipafter}[1]{\setlength{\@dt@sk@a}{#1}}%
\newcommand*{\spaftdate}[1]{\setlength{\@dt@sk@a}{#1}}%
\spaftdate{2\baselineskip}%
\newcommand*{\addrfromskipafter}[1]{\setlength{\@addr@fr@sk@a}{#1}}%
\newcommand*{\spaftfraddr}[1]{\setlength{\@addr@fr@sk@a}{#1}}%
\spaftfraddr{2\baselineskip}%
\newcommand*{\addrfromskipbefore}[1]{\setlength{\@addr@fr@sk@b}{#1}}%
\newcommand*{\spbeffraddr}[1]{\setlength{\@addr@fr@sk@b}{#1}}%
\spbeffraddr{0in}%
\newcommand*{\addrtoskipafter}[1]{\setlength{\@addr@to@sk@a}{#1}}%
\newcommand*{\spafttoaddr}[1]{\setlength{\@addr@to@sk@a}{#1}}%
\spafttoaddr{2\baselineskip}%
\newcommand*{\greettoskipafter}[1]{\setlength{\@greet@to@sk@a}{#1}}%
\newcommand*{\spaftgreet}[1]{\setlength{\@greet@to@sk@a}{#1}}%
\spaftgreet{2\baselineskip}%
\newcommand*{\sigskipbefore}[1]{\setlength{\@sig@sk@b}{#1}}%
\newcommand*{\spbefsig}[1]{\setlength{\@sig@sk@b}{#1}}%
\spbefsig{1\parskip}%
\newcommand*{\sigskipafter}[1]{\setlength{\@sig@sk@a}{#1}}%
\newcommand*{\spaftsig}[1]{\setlength{\@sig@sk@a}{#1}}%
\spaftsig{1\parskip}%
\newcommand*{\sigspace}[1]{\setlength{\@sig@sp}{#1}}%
\sigspace{4\parskip}%
\newcommand*{\postsigskipafter}[1]{\setlength{\@post@sig@sp@a}{#1}}%
\newcommand*{\sppostsig}[1]{\setlength{\@post@sig@sp@a}{#1}}%
\sppostsig{1\parskip}%
\newcommand*{\postmemoskip}[1]{\setlength{\@post@memo@sp}{#1}}%
\newcommand*{\spaftmemo}[1]{\setlength{\@post@memo@sp}{#1}}%
\spaftmemo{\baselineskip}%
\InputIfFileExists{letrinfo.tex}%
  {\typeout{Reading default letter definitions from letrinfo.tex}}%
  {\typeout{All letter definitions must be in newlfm.cls}}%
\newcommand{\showdim}[1]{%
  \txa{Dimensions: #1}%
  \txa{headheight:\the\headheight}%
  \txa{headsep:   \the\headsep}%
  \txa{textheight:\the\textheight}%
  \txa{footskip:  \the\footskip}%
}%
\providecommand{\@ltr@body}{}
\providecommand{\ltrbody}{}
\providecommand{\letterbody}{}
\renewcommand{\ltrbody}[1]{\renewcommand{\@ltr@body}{#1}}
\renewcommand{\letterbody}[1]{\renewcommand{\@ltr@body}{#1}}
\providecommand{\doltr}{}
\providecommand{\doletter}{}
\renewcommand{\doltr}[1]
  {#1 \begin{newlfm} \@ltr@body \end{newlfm} \newpage
  \ifthenelse{\envopen = 1}%
    {\immediate\write14{\string\envlabel{\string#1} }}{}%
}
\newcommand{\envlabel}[1]{#1 \parbox[t][\@boxht][t]{\@boxwd}
  {\@name@to \\ \@addr@to}}
\newcommand{\dims}{left=.165in,top=5pt,textheight=10.2in}
\newcommand{\makeenvst}{
  \immediate\openout14=envelope.tex%
  \immediate\write14
    {\string\documentclass[dvips\@labname]{newlfm}}
  \immediate\write14{\string\usepackage{geometry}}
  \immediate\write14{\string\geometry{\dims}\string\nolines}
  \immediate\write14
    {\string\pagestyle{empty}\string\thispagestyle{empty}}
  \immediate\write14{\string\newpage}
  \immediate\write14{\string\begin{document}}
  \renewcommand{\envopen}{1}
  \ifthenelse{\boolean{@hl}}%
    {\renewcommand{\headrulewidth}{1pt}}%
    {\renewcommand{\headrulewidth}{0pt}}%
  \ifthenelse{\boolean{@fl}}%
    {\renewcommand{\footrulewidth}{1pt}}%
    {\renewcommand{\footrulewidth}{0pt}}%
}
\newcommand{\makeenvfn}{
  \immediate\write14{\string\end{document}}
  \immediate\closeout14
}
\newcommand{\envopen}{0}
\renewcommand{\doletter}[1]
  {\setadrto{#1} \begin{newlfm} \@ltr@body \end{newlfm} \newpage%
  \ifthenelse{\envopen = 1}%
   {\immediate\write14{\string\envlabel{\string#1}}}{}%
}
\newlength{\addv}%
\newlength{\Plg}%
\newenvironment{newlfm}{% Start of fax environment, in fax class%
  \faxblocka%
  \ifthenelse{\boolean{@fax@RA}}%
    {\ifthenelse{\boolean{@fax@bla}}{\Rheader{\usebox{\fba}}}{}%
     \ifthenelse{\boolean{@fax@blb}}{\Rheader{\faxblockb}}{}}%
    {}%
  \ifthenelse{\boolean{@fax@RU}}%
    {\txa{setting up ruh}%
     \ifthenelse{\boolean{@fax@bla}}{\RUheader{\faxblocka}}{}%
     \ifthenelse{\boolean{@fax@blb}}{\RUheader{\faxblockb}}{}}%
    {}%
    \txa{setting up ruh}%
  \renewcommand{\ifta}{0}  \renewcommand{\ifta}{0}%
  \lhead{\@lheader}  \chead{\@cheader}  \rhead{\@rheader}%
  \rfoot{\@rfooter}  \cfoot{\@cfooter}  \lfoot{\@lfooter}%
  \ifthenelse{\boolean{@hl}}%
    {\renewcommand{\headrulewidth}{1pt}}%
    {\renewcommand{\headrulewidth}{0pt}}%
  \ifthenelse{\boolean{@fl}}%
    {\renewcommand{\footrulewidth}{1pt}}%
    {\renewcommand{\footrulewidth}{0pt}}%
  \renewcommand{\ifta}{0}%
  \setlength{\Pwd}{\paperwidth}%
  \sbox{\SCh}{\@Cheader}\sbox{\SLh}{\@Lheader}\sbox{\SRh}{\@Rheader}%
  \sbox{\SCf}{\@Cfooter}\sbox{\SLf}{\@Lfooter}\sbox{\SRf}{\@Rfooter}%
  \renewcommand{\ifta}{0}%
  \settowidth{\hchgt}{\@lmarg}%
  \addtolength{\Pwd}{-\Mwd-1in}%
  \settoheight{\hchgt}{\usebox{\SCh}}%
  \settoheight{\hrhgt}{\usebox{\SRh}}%
  \settoheight{\hlhgt}{\usebox{\SLh}}%
  \settodepth{\addv}{\usebox{\SCh}}%
  \addtolength{\hchgt}{\addv}%
  \settodepth{\addv}{\usebox{\SRh}}%
  \addtolength{\hrhgt}{\addv}%
  \settodepth{\addv}{\usebox{\SLh}}%
  \addtolength{\hlhgt}{\addv}%
  \txa{\string\hchgt: \the\hchgt}%
  \txa{\string\hrhgt: \the\hrhgt}%
  \txa{\string\hlhgt: \the\hlhgt}%
  \settoheight{\fchgt}{\usebox{\SCf}}%
  \settoheight{\frhgt}{\usebox{\SRf}}%
  \settoheight{\flhgt}{\usebox{\SLf}}%
  \settodepth{\fcdth}{\usebox{\SCf}} \addtolength{\fchgt}{\fcdth}%
  \settodepth{\frdth}{\usebox{\SRf}} \addtolength{\frhgt}{\frdth}%
  \settodepth{\fldth}{\usebox{\SLf}} \addtolength{\flhgt}{\fldth}%
  \ifthenelse{\lengthtest{\hlhgt<\hchgt}}%
    {\setlength{\Hhgt}{\hchgt}}%
    {\setlength{\Hhgt}{\hlhgt}}%
  \ifthenelse{\lengthtest{\Hhgt<\hrhgt}}{\setlength{\Hhgt}{\hrhgt}}{}%
  \ifthenelse{\lengthtest{\flhgt<\fchgt}}%
    {\setlength{\Fhgt}{\fchgt}}%
    {\setlength{\Fhgt}{\flhgt}}%
  \ifthenelse{\lengthtest{\Fhgt<\frhgt}}%
    {\setlength{\Fhgt}{\frhgt}}%
    {}%
  \addtolength{\Fhgt}{\baselineskip}%
  \renewcommand{\ifta}{0}%
  \setlength{\Plg}{0in}
  \setlength{\Plg}{\paperheight-\Hhgt-\footskip%
                   -\voffset-\headsep-\footruleskip%
                   -\footrulewidth-\@f@f}%

  \raggedbottom%
  \ifthenelse{\boolean{@fax@hdr@pg}}{\faxpage}{}%
  \newpage%
  \if@twoside \ifodd\c@page%
              \else\thispagestyle{empty}\null\newpage\fi  \fi%
  \c@page\@ne%
  \interlinepenalty=200 % smaller than the TeXbook value%
  \pagestyle{fancy}  \thispagestyle{plain}
  \setlength{\headwidth}{\textwidth}%
  \ifthenelse{\boolean{@B@f}}{\Cfooter{\phantom{\Cfooter}}
    \Rfooter{\phantom{\Rfooter}}\Lfooter{\phantom{\Lfooter}}}{}
  \ifthenelse{\boolean{@B@h}}{\Rheader{\phantom{\Rheader}}
    \Lheader{\phantom{\Lheader}}\Cheader{\phantom{\Cheader}}}{}
  \ifthenelse{\boolean{@B@l}}
    {\ifempty{\@Lmarg}{}{\Lmargin{\phantom{\Lmargin}}}}{}
  \ifthenelse{\boolean{@B@r}}
    {\ifempty{\@Rmarg}{}{\Rmargin{\phantom{\Rmargin}}}}{}
  \ifthenelse{\boolean{@b@f}}  {\rfooter{\phantom{\rfooter}}
    \lfooter{\phantom{\lfooter}} \cfooter{\phantom{\cfooter}}}{}
  \ifthenelse{\boolean{@b@h}}  {\rheader{\phantom{\rheader}}
    \lheader{\phantom{\lheader}} \cheader{\phantom{\cheader}}}{}
  \ifthenelse{\boolean{@b@l}}  {\lmargin{\phantom{\lmargin}}}{}
  \ifthenelse{\boolean{@b@r}}  {\rmargin{\phantom{\rmargin}}}{}
  \openlfm%
  \immediate\openout15=geometry.cfg%
  \immediate\write15{\string\ExecuteOptions{letterpaper}}%
  \immediate\write15{\string\ExecuteOptions{right=\the\@marg@right}}%
  \immediate\write15{\string\ExecuteOptions{left=\the\@marg@left}}%
  \ifempty{\@Lmarg}{}{
    \immediate\write15{\string\ExecuteOptions{reversemarginpar}}%
    \immediate\write15{\string\ExecuteOptions{marginparwidth=\the\Mwd}}%
    \immediate\write15{\string\ExecuteOptions{marginparsep=\@lm@sep@r}}%
  }
  \immediate\write15{\string\ExecuteOptions{top=\@top@m}}%
  \immediate\write15{\string\ExecuteOptions{bottom=\@bot@m}}%
  \immediate\write15{\string\ExecuteOptions{headsep=\@head@m}}%
  \immediate\write15{\string\ExecuteOptions{headheight=\the\Hhgt}}%
  \immediate\write15{\string\ExecuteOptions{footskip=\the\Fhgt}}%
  \immediate\closeout15%
}%
{
  \ifthenelse{\boolean{@sig@p}}{
    \closlfm%
    \@post@sig@bl{\@ps@phr}{\@ps@item}%
    \@post@sig@bl{\@pps@phr}{\@pps@item}%
    \@post@sig@bl{\@ppps@phr}{\@ppps@item}%
    \@post@sig@bl{\@encl@phr}{\@encl@item}%
    \@post@sig@bl{\@cc@phr}{\@cc@item}%
   }{}%
  \ifthenelse{\boolean{@sig@mp}}{
    \@post@sig@bl{\@ps@phr}{\@ps@item}%
    \@post@sig@bl{\@pps@phr}{\@pps@item}%
    \@post@sig@bl{\@ppps@phr}{\@ppps@item}%
    \@post@sig@bl{\@encl@phr}{\@encl@item}%
    \@post@sig@bl{\@cc@phr}{\@cc@item}%
   }{}%
  \ifthenelse{\boolean{@use@envlab}}%
    {\newpage%
     \changepage{11in}{8.5in}{1in}{1in}{0in}{0in}{0in}{0in}{0in}%
     \startlabels%
     \@capitalizeaddressfalse
     \mlabel{\@name@fr \\ \@addr@fr}{\@name@to \\ \@addr@to}}{}%
  \stopletter\@@par\pagebreak\@@par%
  \immediate\write\@auxout{\string\newlabel{totpage}{{\thepage}{0}}}%
}%
\newcommand{\pgrph}[1]{{\bf #1}}%
\pagestyle{plain}%
\pagenumbering{arabic}%
\raggedbottom%
\providecommand{\@texttop}{}%
\renewcommand{\@texttop}
  {\ifnum\c@page=1\vskip \z@ plus.00006fil\relax\fi}%
\onecolumn%
\AtBeginDocument{
  \setlength{\headwidth}{\textwidth}
  \ifthenelse{\boolean{@use@envlab}}
    {
     \IfFileExists{envlab.sty}
       {\makelabels
       }
       {\typeout{The option <useenvlab> was issued.}
        \typeout{File <envlab.sty> cannot be found.}
        \typeout{Option <useenvlab> is disabled}
        \typeout{Please install envlab system.}
        \setboolean{@use@envlab}{false}}}{}
    {}
}
\endinput%

\endinput
%%
%% End of file `newlfm.cls'.
